/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui.stat;

import java.awt.Cursor;
import java.io.IOException;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import org.thema.lucsim.engine.Project;
import weka.core.converters.CSVSaver;

/**
 * Window dialog which prompts the user for the parameters to use to save a 
 * dataset to a .csv file.
 * Said user is able to choose the following options (default values
 * are bracketed):<br>
 * - the first Layer, used to fetch land use data (first layer of the list of
 *   layers the project contains);<br>
 * - the second Layer, used to note if a cell issued from the former layer faced
 *   a transition towards the target state (second layer of the list of layers 
 *   the project contains);<br>
 * - the target state (first state the first layer contains);<br>
 * - if the project contains addtional layers, which ones shall be taken into 
 *   account;<br>
 * - the neighborhood function to use, and wether to use it plain or in rings 
 *   (plain nbCellSq);<br>
 * - the start radius, used to determine the minimal distance between the
 *   current cell under calculation and the cells taken into consideration
 *   (1);<br>
 * - the end radius, used to determine the maximal distance between the current
 *   cell under calculation and the cells taken into consideration (10);<br>
 * - the step to use to grow the neighborhood size (1);<br>
 * - the file where to save the dataset.
 */
public class DataExportDialog extends JDialog {

    private final Project project;

    /**
     * Constructs a DecisionTreeDialog, using the specified Project to retrieve
     * its layers.
     *
     * @param parent JDialog's parent frame (for location purposes)
     * @param project current project (to retrieve project-related data such as
     * layers)
     */
    public DataExportDialog(JFrame parent, Project project) {
        super(parent, false);
        this.project = project;
        initComponents();
        setLocationRelativeTo(parent);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelBackground = new javax.swing.JPanel();
        buttonStart = new javax.swing.JButton();
        buttonClose = new javax.swing.JButton();
        progressBar = new javax.swing.JProgressBar();
        panelOutputFile = new javax.swing.JPanel();
        labelOutputFile = new javax.swing.JLabel();
        labelProgressState2 = new javax.swing.JLabel();
        selectFilePanelOutputFile = new org.thema.common.swing.SelectFilePanel();
        dataExtractorPanel = new DataExtractorPanel(project)
        ;

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Export dataset to CSV");

        panelBackground.setName("panelBackground"); // NOI18N

        buttonStart.setText("Start");
        buttonStart.setName("buttonStart"); // NOI18N
        buttonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonStartActionPerformed(evt);
            }
        });

        buttonClose.setText("Close");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        progressBar.setString("");

        panelOutputFile.setName("panelOutputFile"); // NOI18N
        panelOutputFile.setPreferredSize(new java.awt.Dimension(200, 150));

        labelOutputFile.setFont(new java.awt.Font("Arial", 1, 16)); // NOI18N
        labelOutputFile.setText("Output file");
        labelOutputFile.setName("labelOutputFile"); // NOI18N

        labelProgressState2.setName("labelProgressState2"); // NOI18N

        selectFilePanelOutputFile.setDescription("Output file");
        selectFilePanelOutputFile.setFileDesc("CSV file");
        selectFilePanelOutputFile.setFileExts(".csv");
        selectFilePanelOutputFile.setName("selectFilePanelOutputFile"); // NOI18N
        selectFilePanelOutputFile.setSaveMode(true);

        javax.swing.GroupLayout panelOutputFileLayout = new javax.swing.GroupLayout(panelOutputFile);
        panelOutputFile.setLayout(panelOutputFileLayout);
        panelOutputFileLayout.setHorizontalGroup(
            panelOutputFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelOutputFileLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelOutputFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(selectFilePanelOutputFile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(panelOutputFileLayout.createSequentialGroup()
                        .addComponent(labelOutputFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(labelProgressState2)))
                .addContainerGap())
        );
        panelOutputFileLayout.setVerticalGroup(
            panelOutputFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelOutputFileLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelOutputFileLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelProgressState2)
                    .addComponent(labelOutputFile))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectFilePanelOutputFile, javax.swing.GroupLayout.DEFAULT_SIZE, 31, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout panelBackgroundLayout = new javax.swing.GroupLayout(panelBackground);
        panelBackground.setLayout(panelBackgroundLayout);
        panelBackgroundLayout.setHorizontalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(buttonClose, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(progressBar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonStart, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addComponent(panelOutputFile, javax.swing.GroupLayout.DEFAULT_SIZE, 827, Short.MAX_VALUE)
            .addComponent(dataExtractorPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 827, Short.MAX_VALUE)
        );
        panelBackgroundLayout.setVerticalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBackgroundLayout.createSequentialGroup()
                .addComponent(dataExtractorPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panelOutputFile, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(buttonClose, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(progressBar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(buttonStart, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_buttonCloseActionPerformed

    private void buttonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonStartActionPerformed
        if (selectFilePanelOutputFile.getSelectedFile() == null) {
            JOptionPane.showMessageDialog(this, "No output file has been given.");
            return;
        }

        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        buttonStart.setEnabled(false);

        new Thread(() -> {
            try {
            CSVSaver csvSaver = new CSVSaver();
            csvSaver.setFile(selectFilePanelOutputFile.getSelectedFile());
            csvSaver.setInstances(dataExtractorPanel.getDataExtractor().getFullDataset());
            csvSaver.writeBatch();
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            } finally {
                setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
                buttonStart.setEnabled(true);
            }
        }).start();

        
    }//GEN-LAST:event_buttonStartActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonClose;
    private javax.swing.JButton buttonStart;
    private org.thema.lucsim.gui.stat.DataExtractorPanel dataExtractorPanel;
    private javax.swing.JLabel labelOutputFile;
    private javax.swing.JLabel labelProgressState2;
    private javax.swing.JPanel panelBackground;
    private javax.swing.JPanel panelOutputFile;
    private javax.swing.JProgressBar progressBar;
    private org.thema.common.swing.SelectFilePanel selectFilePanelOutputFile;
    // End of variables declaration//GEN-END:variables
}
